#include <avr/io.h>
#include <avr/interrupt.h>
#include <avr/pgmspace.h>
#include <avr/eeprom.h>
#include <stdlib.h>
#include "global.h"
#include "rf12.h"     

#define F_CPU 	10000000UL	// 16000000UL
#include <util/delay.h>

#define TASTER_DDR	PORTB
#define TASTER_PORT	PORTB
#define TASTER_PIN	PINB
#define TASTER		1

#define LED_PORT	PORTD
#define LED_DDR		DDRD

#define LED1		6
#define LED2		5
#define LEDOPTO		4	//	PORTD4	- POWER

	//	PORTD0 AVR-RX
	//	PORTD1 AVR-TX

void init(void);
void send(void);
void receive(void);

int main(void)
{
	init();
			
	unsigned char i;
	for (i=0; i<3; i++)
	{	
		LED_PORT &= ~(1<<LED2);		// LED ausschalten
		_delay_ms(100);
		LED_PORT |= (1<<LED2);		// LED einschalten
		_delay_ms(100);
	}
	
		
	for (;;)		// Endlosschleife
	{

		while (!(TASTER_PIN&(1<<TASTER))); // Nach Tastendruck senden

		send();

		for (i=0; i<2; i++)
		{	
			LED_PORT |= (1<<LED1);		// LED einschalten
			_delay_ms(10);
			LED_PORT &= ~(1<<LED1);		// LED ausschalten
			_delay_ms(10);
		}

		unsigned char i;
		for (i=0; i<100; i++)
			_delay_ms(10);

	//	receive();
	}
}

void init(void)
{
	LED_DDR |= (1<<LED1)|(1<<LED2)|(1<<LEDOPTO);	// LEDs einstellen
	LED_PORT |= (1<<LEDOPTO);		// Funkmodul Strom einschalten

	TASTER_DDR &= ~(1<<TASTER);		// Taster einstellen
	TASTER_PORT &= ~(1<<TASTER);	// Pullup ausschalten

	rf12_init();					// ein paar Register setzen (z.B. CLK auf 10MHz)
	rf12_setfreq(RF12FREQ(433.92));	// Sende/Empfangsfrequenz auf 433,92MHz einstellen
	rf12_setbandwidth(4, 1, 4);		// 200kHz Bandbreite, -6dB Verstrkung, DRSSI threshold: -79dBm 
	rf12_setbaud(9600);				// 9600 baud
	rf12_setpower(0, 6);			// 1mW Ausgangangsleistung, 120kHz Frequenzshift
}

void receive(void)
{	
	unsigned char test[32];	
	rf12_rxdata(test,32);	
	// daten verarbeiten
}

void send(void)
{	
	unsigned char test[]="Ich bin ein 433MHz Pirat !!!!!!!!\0";	
	rf12_txdata(test,32);
}

